<template>
  <div class="app-container">

    <!-- <el-row style="margin-left: 10px" :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
        >导出所有数据</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row> -->
    <el-row v-if="checkResultList && checkResultList.length > 0">
      <el-col
        :xl="8"
        :lg="8"
        :md="12"
        :sm="12"
        :xs="12"
        v-for="item in checkResultList"
        :key="item.id"
      >
      <el-card class="box-card" >
        <div slot="header" class="clearfix">
          <span>{{ item.unitName +item.whichYear+"年核算报告" }}</span>
          <el-button style="float: right; padding: 3px 0" type="text" @click="handleDetail(item)">核算</el-button>
        </div>
        <div class="text item">合同<span class="time">{{ item.contractName }}</span></div>
        <div class="text item">最近扣减金额<span class="time">{{ item.latestDeductMoney ?  item.latestDeductMoney:0 }}</span></div>
        <div class="text item">累计扣减金额<span class="time">{{ item.deductMoney ? item.deductMoney:0}}</span></div>
        <div class="text item">最近核算月份
          <span v-if="item.latestMonth" class="time">{{ item.whichYear }}年{{ item.latestMonth }}月</span>
          <span v-else class="time">暂无</span>
        </div>
        <el-button size="small" type="primary" round style="float: right;margin-left: 18px;" @click="handleExport(item)" v-hasPermi="['system:calculate:report:export']">导出</el-button>
        <el-button size="small" round style="float: right;margin-bottom: 18px;" @click="handlePublish(item)"  v-hasPermi="['system:calculate:report:status']">确认发布</el-button>
      </el-card>
      </el-col>
    </el-row>
    <el-empty v-else description="暂无数据"></el-empty>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog :title="detailTitle" :visible.sync="detailOpen" width="760px" append-to-body>
      <div style="display: flex; flex-direction: row; width: 100%;margin-bottom: 10px; justify-content: center; align-items: center">
        <div style="line-height: 16px">应用规则：</div>
        <div v-for="ruleItem in detail.ruleList" :key="ruleItem.id" style="display: flex; margin-right: 50px;">
          <div style="line-height: 16px;margin-right: 10px;display: flex; align-items: center">{{ ruleItem.scoreCondition }}</div>
          <div style="line-height: 16px;max-width: 300px;word-wrap:break-word;word-break:normal;color: #2273b9">{{ ruleItem.description }}</div>
        </div>
      </div>

      <el-descriptions class="margin-top" :column="3" border>
<!--        <template slot="extra">-->
<!--          <el-button type="primary" size="small">操作</el-button>-->
<!--        </template>-->
        <el-descriptions-item>
          <template slot="label">
            <i class="el-icon-user"></i>
            核算对象
          </template>
          {{detail.unitName}}
        </el-descriptions-item>
        <el-descriptions-item>
          <template slot="label">
            <i class="el-icon-s-management"></i>
            合同名称
          </template>
          {{detail.contractName}}
        </el-descriptions-item>
      </el-descriptions>
        <el-table
          align="center"
          :data="detail.recordList"
          show-summary
          :summary-method="getSummaries"
          style="width: 100%;text-align:center">
          <el-table-column
            prop="whichMonth"
            label="核算月份"
            width="180">
          <template slot-scope="scope">
            <span> {{ scope.row.whichYear +'年'+ scope.row.whichMonth+ '月'}}</span>
          </template>
          </el-table-column>
          <el-table-column
            prop="score"
            label="考核分数"
           >
            <template slot-scope="scope">
              <el-link @click="toScorePage(scope.row,detail.unitId)">{{scope.row.score}}</el-link>
            </template>
          </el-table-column>
          <el-table-column
            label="扣减金额(元)"
            prop="deductMoney"
            width="180">
            <template slot-scope="scope">
              <el-input
                type="number"
                :precision="2" :step="0.1"
                :min="0" :max="1000000"
                v-model="scope.row.deductMoney"
                :disabled="!checkRole(['admin'])"
                placeholder="请输入扣减金额">
              </el-input>
            </template>
          </el-table-column>
          <el-table-column
            prop="status"
            label="发布状态"
            width="150"
            v-if="checkRole(['admin'])"
          >
            <template slot-scope="scope">
              <el-button
                size="small"
                type="text"
                v-if="scope.row.status === 'PUBLISHED'"
                @click="handleDetailPublish(scope.row)"
              >
                取消发布
              </el-button>
              <el-button
                v-else
                size="small"
                type="text"
                @click="handleDetailPublish(scope.row)"
                >
                发布
              </el-button>
            </template>
          </el-table-column>
        </el-table>
        <div slot="footer" class="dialog-footer">
          <el-button @click="cancel">取 消</el-button>
          <el-button type="primary" @click="submitForm" v-hasPermi="['system:calculate:report:backfill']">核算</el-button>
        </div>
    </el-dialog>

    <!-- 添加或修改考核结果对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="cancel">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { getCalculateReports, getCalculateReportById, backfill, updatePublishStatus,updatePublishStatusById } from "@/api/platform/calculate-report";
import { checkPermi, checkRole } from "@/utils/permission"; // 权限判断函数
export default {
  name: "CheckResult",
  data() {
    return {
      manualOpen: false,
      detailTitle: '',
      detailOpen: false,
      detail:{},
      manualScoreOpen: false,
      manualScoreForm: {},
      manualScoreTitle: '',
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 考核结果表格数据
      checkResultList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 逻辑删除时间范围
      daterangeCheckTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        checkUnitId: null,
        checkTime: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    checkPermi,
    checkRole,
    frequencyFormatter(row) {
      if (row.frequency === "1") {
        return "月度考核"
      }
      if (row.frequency === "2") {
        return "季度考核"
      }
    },
    examineRangeFormatter(row) {
      if (row.examineRange === "1") {
        return "分局考核"
      }
      if (row.examineRange === "2") {
        return "市局考核"
      }
    },
    /** 查询考核结果列表 */
    getList() {
      this.loading = true;
      if (null != this.daterangeCheckTime && '' != this.daterangeCheckTime) {
        this.queryParams["start"] = this.daterangeCheckTime[0];
        this.queryParams["end"] = this.daterangeCheckTime[1];
      }
      getCalculateReports(this.queryParams).then(response => {
        this.checkResultList = response.data;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.detailOpen = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        checkUnitId: null,
        checkPublishId: null,
        checkScore: null,
        systemScore: null,
        manualScore: null,
        checkTime: null,
        createTime: null,
        updateTime: null,
        deleted: null
      };
      this.resetForm("form");
    },
    cancelManualScore() {
      this.manualScoreForm = {};
      this.manualScoreTitle = "";
      this.manualScoreOpen = false;
    },
    submitManualScore() {
      if (! this.manualScoreForm.manualScore) {
        this.$modal.msgWarning("请填写分数");
        return
      }
      // manualScore(this.manualScoreForm).then(res => {
      //   this.$modal.msgSuccess("操作成功");
      //   this.cancelManualScore();
      //   this.getList();
      // })
    },
    handleDetail(row) {
      getCalculateReportById(row.contractId,row.whichYear).then(res => {
        this.detail = res.data
        this.detailTitle = row.unitName + '考核结果'
        this.detailOpen = true
      })
    },
    handlePublish(row) {
      let text = row.status === 'PUBLISHED' ? '取消发布' : '发布';
      this.$modal.confirm('确认要【' + text + "】【" +  row.unitName +row.whichYear+"年】" + '的核算报告吗？').then(function() {
        // return publishCheckResult(ids);
      }).then(() => {
        updatePublishStatus(row.contractId,row.whichYear).then(res => {
          this.getList();
          this.$modal.msgSuccess(text + "成功");
        })
      }).catch(() => {});

    },
    handleDetailPublish(row){
      let text = row.status === 'PUBLISHED' ? '取消发布' : '发布';
      row.status = row.status === 'PUBLISHED' ? 'UNPUBLISHED' : 'PUBLISHED'
      updatePublishStatusById(row.id,row.status).then(res => {
        this.$modal.msgSuccess(text + "成功");
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeCheckTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 回填金额 */
    submitForm() {
      let data = {
        id: this.detail.id,
        recordList: this.detail.recordList
      }
      if (data.recordList.length > 0) {
        backfill(data).then(res => {
          if (res.code === 200) {
            this.$message.success("操作成功");
            this.detailOpen = false;
            this.getList();
          }
        })
      } else {
        this.detailOpen = false;
      }

    },
    /** 导出按钮操作 */
    handleExport(item) {
      this.download('calculate-report/export', {
        ...{ 'calculateId': item.id, 'contractId': item.contractId},
      }, `${item.contractName}运维核算.xlsx`)
    },
    /** 合计行 */
    getSummaries(param) {
      const { columns, data } = param;
      const sums = [];
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '合计';
          return;
        }

        const values = data.map(item => Number(item[column.property]));
        if (!values.every(value => isNaN(value))) {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr);
            if (!isNaN(value)) {
              return prev + curr;
            } else {
              return prev;
            }
          }, 0);
          if (column.property === 'score') {
            sums[index] = '-';
          }
          if (column.property === 'deductMoney') {
            sums[index] += ' 元';
          }
        } else {
          sums[index] = '-';
        }
      });
      return sums;
    },
    toScorePage(row,unitId) {
      // 使用Vue Router进行页面跳转
      const { startDate, endDate } = this.getMonthDatesFormatted(row.whichYear, row.whichMonth);
      const time = [startDate,endDate]
      this.$router.push({path: '/contract/score', query: {unitId: unitId, time: time}});
    },
    getMonthDatesFormatted(year, month) {
      const startDate = new Date(year, month - 1, 1);
      const endDate = new Date(year, month, 0);

      // 格式化成 YYYY-MM-DD
      const formatDate = (date) => {
        const yyyy = date.getFullYear();
        const mm = String(date.getMonth() + 1).padStart(2, '0');
        const dd = String(date.getDate()).padStart(2, '0');
        return `${yyyy}-${mm}-${dd}`;
      };

      return {
        startDate: formatDate(startDate),
        endDate: formatDate(endDate)
      };
    },
    // 删除按钮
    handleDelete() {

    }
  }
};
</script>
<style>
  .text {
    font-size: 14px;
  }
  .time {
    font-size: 13px;
    color: #999;
    margin-left: 10px;
  }
  .item {
    margin-bottom: 18px;
  }
  .clearfix:before,
  .clearfix:after {
    display: table;
    content: "";
  }
  .clearfix:after {
    clear: both
  }
  .box-card {
    width: calc(33% - 20px);
    min-width: 300px;
    margin: 15px 10px;
  }
</style>
